package org.stm.base.applicable.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.stm.base.applicable.entity.StApplicable;
import org.stm.base.applicable.service.IStApplicableService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: st_applicable
 * @Author: yzh
 * @Date:   2023-03-04
 * @Version: V1.0
 */
@Api(tags="适用对象")
@RestController
@RequestMapping("/base.applicable/stApplicable")
@Slf4j
public class StApplicableController extends JeecgController<StApplicable, IStApplicableService> {
	@Autowired
	private IStApplicableService stApplicableService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stApplicable
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "适用对象-分页列表查询")
	@ApiOperation(value="适用对象-分页列表查询", notes="适用对象-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<StApplicable>> queryPageList(StApplicable stApplicable,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StApplicable> queryWrapper = QueryGenerator.initQueryWrapper(stApplicable, req.getParameterMap());
		Page<StApplicable> page = new Page<StApplicable>(pageNo, pageSize);
		IPage<StApplicable> pageList = stApplicableService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stApplicable
	 * @return
	 */
	@AutoLog(value = "适用对象-添加")
	@ApiOperation(value="适用对象-添加", notes="适用对象-添加")
	@RequiresPermissions("base.applicable:st_applicable:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StApplicable stApplicable) {
		stApplicableService.save(stApplicable);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stApplicable
	 * @return
	 */
	@AutoLog(value = "适用对象-编辑")
	@ApiOperation(value="适用对象-编辑", notes="适用对象-编辑")
	@RequiresPermissions("base.applicable:st_applicable:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StApplicable stApplicable) {
		stApplicableService.updateById(stApplicable);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "适用对象-通过id删除")
	@ApiOperation(value="适用对象-通过id删除", notes="适用对象-通过id删除")
	@RequiresPermissions("base.applicable:st_applicable:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stApplicableService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "适用对象-批量删除")
	@ApiOperation(value="适用对象-批量删除", notes="适用对象-批量删除")
	@RequiresPermissions("base.applicable:st_applicable:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stApplicableService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "适用对象-通过id查询")
	@ApiOperation(value="适用对象-通过id查询", notes="适用对象-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<StApplicable> queryById(@RequestParam(name="id",required=true) String id) {
		StApplicable stApplicable = stApplicableService.getById(id);
		if(stApplicable==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stApplicable);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stApplicable
    */
    @RequiresPermissions("base.applicable:st_applicable:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StApplicable stApplicable) {
        return super.exportXls(request, stApplicable, StApplicable.class, "st_applicable");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("base.applicable:st_applicable:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StApplicable.class);
    }

}
